/**
 * ---------------------------------------------------------------------
 *
 * GLPI - Gestionnaire Libre de Parc Informatique
 *
 * http://glpi-project.org
 *
 * @copyright 2015-2024 Teclib' and contributors.
 * @copyright 2003-2014 by the INDEPNET Development Team.
 * @licence   https://www.gnu.org/licenses/gpl-3.0.html
 *
 * ---------------------------------------------------------------------
 *
 * LICENSE
 *
 * This file is part of GLPI.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * ---------------------------------------------------------------------
 */
export class GlpiFormEditorController{#t;#e;#i;#o;#a;constructor(t,e,i,o){this.#t=t;this.#e=e;this.#i=i;this.#o=o;this.#a={};if($(this.#t).prop("tagName")!="FORM"){throw new Error("Target must be a valid form")}if(this.#s(this.#i).length==0){throw new Error(`Invalid default question type: ${i}`)}this.#n();this.#d();this.#r();$(this.#t).find("[data-glpi-form-editor-dynamic-input]").each(((t,e)=>{this.#l(e)}));this.#c($(this.#t).find("[data-glpi-form-editor-blocks]"));if(this.#m()===0){$(this.#t).find("[data-glpi-form-editor-form-details-name]")[0].select()}}#d(){const t=_.throttle((()=>this.#n()),100);$(window).on("resize",(()=>t()));$(this.#t).on("glpi-ajax-controller-submit-success",(()=>this.#p()));$(document).on("click","[data-glpi-form-editor]",(()=>{this.#f();$(".simulate-focus").removeClass("simulate-focus")}));$(document).on("tinyMCEChange",((t,e)=>this.#g(e)));$(document).on("tinyMCEClick",((t,e)=>this.#h(e)));$(this.#t).on("submit",(t=>{try{this.computeState()}catch(e){t.preventDefault();t.stopPropagation();glpi_toast_error(__("An unexpected error occurred"));throw e}}));$(this.#t).on("glpi-ajax-controller-submit-success",(()=>{this.#u();const t=$(this.#t).find("[data-glpi-form-editor-save-and-preview-action]");if(t.get(0)===$(document.activeElement).get(0)){window.open(t.data("glpi-form-editor-preview-url"),"_blank")}}));let e=window.glpiUnsavedFormChanges;setInterval((()=>{if(e!==window.glpiUnsavedFormChanges){this.#u()}e=window.glpiUnsavedFormChanges}),500);const i=["click","change","input"];i.forEach((t=>{const e=`data-glpi-form-editor-on-${t}`;$(document).on(t,`${this.#t} [${e}]`,(t=>{const i=$(t.currentTarget);const o=i.attr(e);try{this.#$(o,i,t)}catch(t){glpi_toast_error(__("An unexpected error occurred"));throw t}}))}))}registerQuestionTypeOptions(t,e){this.#a[t]=e}#p(){if(this.#e){this.#v()}}#$(t,e,i){let o=true;i.stopPropagation();switch(t){case"set-active":this.#y(e);o=false;break;case"add-question":this.#b(e.closest(`\n                        [data-glpi-form-editor-active-form],\n                        [data-glpi-form-editor-active-section],\n                        [data-glpi-form-editor-active-question],\n                        [data-glpi-form-editor-active-comment]\n                    `));break;case"delete-question":this.#I(e.closest("[data-glpi-form-editor-question]"));break;case"toggle-mandatory-question":this.#C(e.closest("[data-glpi-form-editor-question]"),e.prop("checked"));break;case"compute-dynamic-input":this.#l(e[0]);break;case"change-question-type-category":this.#w(e.closest("[data-glpi-form-editor-question]"),e.val());break;case"change-question-type":this.#k(e.closest("[data-glpi-form-editor-question]"),e.val());break;case"add-section":this.#_(e.closest(`\n                        [data-glpi-form-editor-active-form],\n                        [data-glpi-form-editor-active-section],\n                        [data-glpi-form-editor-active-section],\n                        [data-glpi-form-editor-active-question],\n                        [data-glpi-form-editor-active-comment]\n                    `));break;case"delete-section":this.#q(e.closest("[data-glpi-form-editor-section]"));break;case"build-move-section-modal-content":this.#A();o=false;break;case"reorder-sections":this.#S();break;case"merge-with-previous-section":this.#T(e.closest("[data-glpi-form-editor-section]"));break;case"collapse-section":this.#E(e.closest("[data-glpi-form-editor-section]"));break;case"duplicate-section":this.#M(e.closest("[data-glpi-form-editor-section]"));break;case"duplicate-question":this.#D(e.closest("[data-glpi-form-editor-question]"));break;case"duplicate-comment":this.#x(e.closest("[data-glpi-form-editor-comment]"));break;case"question-sort-update":break;case"add-comment":this.#U(e.closest(`\n                        [data-glpi-form-editor-active-form],\n                        [data-glpi-form-editor-active-section],\n                        [data-glpi-form-editor-active-question],\n                        [data-glpi-form-editor-active-comment]\n                    `));break;case"delete-comment":this.#Q(e.closest("[data-glpi-form-editor-comment]"));break;default:throw new Error(`Unknown action: ${t}`)}if(o){window.glpiUnsavedFormChanges=true}this.#r()}computeState(){const t={question:0,comment:0};const e=$(this.#t).find("[data-glpi-form-editor-section]");e.each(((e,i)=>{this.#F($(i).find("[data-glpi-form-editor-section-details]"),"section",e);this.#B($(i),e);this.#P($(i));const o=$(i).find("[data-glpi-form-editor-question], [data-glpi-form-editor-comment]");o.each(((e,o)=>{const a=$(o).is("[data-glpi-form-editor-question]")?"question":"comment";this.#F($(o),a,t[a]);this.#B($(o),e);this.#P($(o));this.#R($(o),$(i));t[a]++}))}))}#r(){this.#V();this.#j();this.#H();this.#N();this.#z()}#F(t,e,i){const o=t.find("input[name], select[name], textarea[name]");o.each(((t,o)=>{const a=$(o).attr("name");if(!$(o).data("glpi-form-editor-original-name")){$(o).attr("data-glpi-form-editor-original-name",a)}let s=$(o).data("glpi-form-editor-original-name");let n="";if(e==="section"){n=`_sections[${i}]`}else if(e==="question"){n=`_questions[${i}]`;const t=$(o).attr("data-glpi-form-editor-specific-question-extra-data")!==undefined;if(t){n+=`[extra_data]`}}else if(e==="comment"){n=`_comments[${i}]`}else if(e==="temp"){n=`_temp[${i}]`}else{throw new Error(`Unknown item type: ${e}`)}let d="";const r=new RegExp(/\[([\w-[\]]*)\]$/,"g");if(typeof s==="string"&&r.test(s)){d=s.match(r);s=s.replace(d,"")}$(o).attr("name",`${n}[${s}]${d}`)}))}#B(t,e){this.#L(t,"rank",e)}#P(t){const e=this.#O(t,"id");if(e==0){this.#L(t,"id",getUUID());this.#L(t,"_use_uuid",1)}}#R(t,e){const i=this.#O(e,"id");this.#L(t,"forms_sections_id",i);this.#L(t,"_use_uuid_for_sections_id",this.#O(e,"_use_uuid"))}#g(t){const e=$(t.target.container).closest("[data-glpi-form-editor-question-description]");if(e.length>0){this.#W(e,t.level.content)}}#h(t){const e=$(t.target).closest("#tinymce").data("id");const i=$(`#${e}`);this.#y(i.closest('[data-glpi-form-editor-on-click="set-active"]'))}#n(){const t=document.body.offsetHeight;const e=$(this.#t).offset().top;const i=1;let o=t-e-i;if($("#debug-toolbar").length>0){const t=$("#debug-toolbar").height();o-=t}$(this.#t).css("height",`${o}`)}#v(){const t=$("#main-form button[name=update]");t.find(".ti-plus").removeClass("ti-plus").addClass("ti-device-floppy");t.find(".add-label").text(__("Save"));t.prop("title",__("Save"));const e=$("#main-form button[name=delete]");e.removeClass("d-none");this.#e=false}#W(t,e){const i=document.createElement("div");i.innerHTML=e;const o=i.textContent||i.innerText||"";const a=o.length;if(a==0){t.attr("data-glpi-form-editor-question-extra-details","")}else{t.removeAttr("data-glpi-form-editor-question-extra-details")}}#y(t){const e=["form","section","question","comment"];e.forEach((t=>{$(this.#t).find(`[data-glpi-form-editor-active-${t}]`).removeAttr(`data-glpi-form-editor-active-${t}`)}));if(t!==null){e.forEach((e=>{if(t.data(`glpi-form-editor-${e}-details`)!==undefined){t.closest(`[data-glpi-form-editor-${e}]`).attr(`data-glpi-form-editor-active-${e}`,"")}else if(t.data(`glpi-form-editor-${e}`)!==undefined){t.attr(`data-glpi-form-editor-active-${e}`,"")}}));const i=t.closest("[data-glpi-form-editor-section]");if(i.hasClass("section-collapsed")){return}t.addClass("active")}}#X(t,e){let i;let o;if(t.data("glpi-form-editor-question")!==undefined||t.data("glpi-form-editor-comment")!==undefined){i=t;o="after"}else if(t.data("glpi-form-editor-section")!==undefined){i=t.closest("[data-glpi-form-editor-section]").find("[data-glpi-form-editor-section-blocks]");o="prepend"}else if(t.data("glpi-form-editor-form")!==undefined){i=$(this.#t).find("[data-glpi-form-editor-section]:last-child").find("[data-glpi-form-editor-section-blocks]:last-child");o="append"}else{throw new Error("Unexpected target")}return this.#G(e,i,o)}#b(t){const e=this.#s(this.#i).children();const i=this.#X(t,e);this.#y(i);i.find("[data-glpi-form-editor-question-details-name]")[0].focus()}#I(t){if($(this.#t).find("[data-glpi-form-editor-question]").length==1&&this.#J()==1){this.#f()}else{if(t.prev().length>0){this.#y(t.prev())}else{this.#y(t.closest("[data-glpi-form-editor-section]"))}}t.remove()}#C(t,e){if(e){t.addClass("mandatory-question")}else{t.removeClass("mandatory-question")}}#s(t){const e=$.escapeSelector(t);return $(this.#o).find(`[data-glpi-form-editor-question-template=${e}]`)}#G(t,e,i="append",o=false){const a=t.clone();const s=[];const n=[];const d=[];a.find("textarea").each((function(){let t=$(this).attr("id");const e=_.cloneDeep(window.tinymce_editor_configs[t]);const i=getUUID();$(this).attr("id",`_tinymce_${i}`);t=$(this).attr("id");e.selector=`#${t}`;s.push(e);window.tinymce_editor_configs[t]=e}));a.find("select").each((function(){let e;if(o){e=$(this).select2("data");$(this).removeClass("select2-hidden-accessible");$(this).removeAttr("data-select2-id");$(this).next(".select2-container").remove();t.find(`#${$(this).attr("id")}`).each((function(){const t=$(this).attr("data-glpi-form-editor-original-id")??$(this).attr("id");const i={...window.select2_configs[t]};i.field_id=$(this).attr("id");n.push(i);d[$(this).attr("id")]=e;$(this).select2("destroy")}))}const i=$(this).attr("data-glpi-form-editor-original-id")??$(this).attr("id");const a={...window.select2_configs[i]};if(i!==undefined&&a!==undefined){const t=getUUID();$(this).attr("id",t);$(this).attr("data-glpi-form-editor-original-id",i);if($(this).hasClass("select2-hidden-accessible")===false&&a!==undefined){a.field_id=t;n.push(a);if(e){d[t]=e}}}}));if(o){this.#F(a,"temp",getUUID())}switch(i){case"append":a.appendTo(e);break;case"prepend":a.prependTo(e);break;case"before":a.insertBefore(e);break;case"after":a.insertAfter(e);break;default:throw new Error(`Unknown action: ${i}`)}s.forEach((t=>tinyMCE.init(t)));n.forEach((t=>{if(t.type==="ajax"){const e=setupAjaxDropdown(t);if(d[t.field_id]){e.find("option").remove();for(const i of d[t.field_id]){const t=new Option(i.text,i.id,true,true);e.append(t).trigger("change");e.trigger("select2:select",{data:i})}}}else if(t.type==="adapt"){const e=setupAdaptDropdown(t);if(d[t.field_id]){for(const i of d[t.field_id]){e.val(i.id).trigger("change")}}}}));const r=a.find('[data-bs-toggle="tooltip"]');[...r].map((t=>new bootstrap.Tooltip(t)));const l=a.find('[data-bs-toggle="popover"]');[...l].map((t=>new bootstrap.Popover(t)));if(o){this.computeState()}return a}#O(t,e){if(t.data("glpi-form-editor-section")!==undefined){t=t.find("[data-glpi-form-editor-section-details]")}let i=t.find(`input[name=${e}]`);if(i.length>0){return t.find(`input[name=${e}]`).val()}i=t.find(`input[data-glpi-form-editor-original-name=${e}]`);if(i.length>0){return t.find(`input[data-glpi-form-editor-original-name=${e}]`).val()}throw new Error(`Field not found: ${e}`)}#L(t,e,i){if(t.data("glpi-form-editor-section")!==undefined){t=t.find("[data-glpi-form-editor-section-details]")}let o=t.find(`input[name=${e}]`);if(o.length>0){return t.find(`input[name=${e}]`).val(i)}o=t.find(`input[data-glpi-form-editor-original-name=${e}]`);if(o.length>0){return t.find(`input[data-glpi-form-editor-original-name=${e}]`).val(i)}throw new Error(`Field not found: ${e}`)}#l(t){$(t).css("width",getRealInputWidth(t,"1.2rem"))}#w(t,e){const i=this.#O(t,"category");if(i===e){return}const o=$.escapeSelector(e);const a=$(this.#o).find(`option[data-glpi-form-editor-question-type=${o}]`);const s=t.find("[data-glpi-form-editor-question-type-selector]");s.children().remove();this.#G(a,s);this.#L(t,"category",e);const n=s.parent();if(a.length<=1){n.addClass("d-none")}else{n.removeClass("d-none")}s.trigger("change")}#k(t,e){const i=this.#O(t,"type");if(i===e){return}const o=this.#a[i].extractDefaultValue(t);const a=t.find("[data-glpi-form-editor-question-type-specific]");a.children().remove();const s=t.find("[data-glpi-form-editor-specific-question-options]");s.children().remove();const n=this.#s(e).find("[data-glpi-form-editor-question-type-specific]").children();const d=this.#s(e).find("[data-glpi-form-editor-specific-question-options]").children();this.#G(n,a);this.#G(d,s);this.#L(t,"type",e);const r=this.#s(e).find("[data-glpi-form-editor-question-details]").data("glpi-form-editor-allow-anonymous");t.find("[data-glpi-form-editor-blacklisted-question-type-warning]").toggleClass("d-none",r==1);this.#a[e].convertDefaultValue(t,o);$(document).trigger("glpi-form-editor-question-type-changed",[t,e])}#_(t){let e;let i;let o;if(t.data("glpi-form-editor-question")!==undefined||t.data("glpi-form-editor-comment")!==undefined){e=t.closest("[data-glpi-form-editor-section]");i="after";o=$(t).nextAll()}else if(t.data("glpi-form-editor-section")!==undefined){e=t.closest("[data-glpi-form-editor-section]");i="after";o=$(t).closest("[data-glpi-form-editor-section]").find("[data-glpi-form-editor-question]")}else if(t.data("glpi-form-editor-form")!==undefined){e=t.closest("[data-glpi-form-editor-form]").find("[data-glpi-form-editor-section]:last-child");i="after";o=null}else{throw new Error("Unexpected target")}const a=$(this.#o).find("[data-glpi-form-editor-section-template]").children();const s=this.#G(a,e,i);if(o!==null&&o.length>0){o.detach().appendTo(s.find("[data-glpi-form-editor-section-blocks]"));o.each(((t,e)=>{this.#K($(e))}))}this.#y(s.find("[data-glpi-form-editor-section-details]"));this.#c(s);s.find("[data-glpi-form-editor-section-details-name]")[0].focus()}#q(t){if(t.prev().length==0){if(t.next().length>0&&this.#J()>2){this.#y(t.next())}else{this.#f()}}else{const e=t.prev().find("[data-glpi-form-editor-question]");if(e.length>0){this.#y(e.last())}else{if(this.#J()==2){this.#f()}else{this.#y(t.prev())}}}t.remove()}#U(t){const e=$(this.#o).find("[data-glpi-form-editor-comment-template]").children();const i=this.#X(t,e);this.#y(i);i.find("[data-glpi-form-editor-comment-details-name]")[0].focus()}#Q(t){if($(this.#t).find("[data-glpi-form-editor-comment]").length==1&&this.#J()==1){this.#f()}else{if(t.prev().length>0){this.#y(t.prev())}else{this.#y(t.closest("[data-glpi-form-editor-section]"))}}t.remove()}#V(){const t=$(this.#t).find("[data-glpi-form-editor-block]").length;if(t==0){$("[data-glpi-form-editor-on-click='add-section']").addClass("d-none")}else{$("[data-glpi-form-editor-on-click='add-section']").removeClass("d-none")}}#J(){return $(this.#t).find("[data-glpi-form-editor-section]").length}#m(){return $(this.#t).find("[data-glpi-form-editor-question]").length}#N(){if(this.#J()<=1){$(this.#t).find("[data-glpi-form-editor-section-details]").addClass("d-none");$(this.#t).find("[data-glpi-form-editor-section-number-display]").addClass("d-none")}else{$(this.#t).find("[data-glpi-form-editor-section-details]").removeClass("d-none");$(this.#t).find("[data-glpi-form-editor-section-number-display]").removeClass("d-none")}}#H(){const t=$(this.#t).find("[data-glpi-form-editor-section]");t.each(((e,i)=>{const o=$(i).find("[data-glpi-form-editor-section-number-display]");o.html(__("Step %1$d of %2$d").replace("%1$d",e+1).replace("%2$d",t.length))}))}#z(){$(this.#t).find(`[data-glpi-form-editor-on-click="merge-with-previous-section"]`).removeClass("d-none");$(this.#t).find(`[data-glpi-form-editor-section]:first-child`).find(`[data-glpi-form-editor-on-click="merge-with-previous-section"]`).addClass("d-none")}#c(t){t.each(((t,e)=>{const i=$(e).find("[data-glpi-form-editor-section-blocks]");sortable(i,{handle:"[data-glpi-form-editor-question-handle]",acceptFrom:"[data-glpi-form-editor-section-blocks]",placeholderClass:"glpi-form-editor-drag-question-placeholder mb-3"})}));t.find("[data-glpi-form-editor-section-blocks]").on("sortupdate",(t=>{this.#$("question-sort-update",null,t)}));t.find("[data-glpi-form-editor-section-blocks]").on("sortstart",(()=>{$(this.#t).addClass("disable-focus")}));t.find("[data-glpi-form-editor-section-blocks]").on("sortstop",(t=>{if($(t.detail.item).hasClass("sortable-dragging")){return}this.#K($(t.detail.item));$(this.#t).removeClass("disable-focus");$(".content-editable-tinymce").removeClass("simulate-focus")}))}#A(){const t=$(this.#t).find("[data-glpi-form-editor-move-section-modal-items]");t.children().remove();$(this.#t).find("[data-glpi-form-editor-section]").each(((e,i)=>{const o=this.#O($(i),"name");const a=$("[data-glpi-form-editor-move-section-modal-item-template]").clone();const s=getUUID();$(i).attr("data-glpi-form-editor-move-section-modal-uuid",s);a.find("[data-glpi-form-editor-move-section-modal-item-section-key]").attr("data-glpi-form-editor-move-section-modal-item-section-key",s);a.find("[data-glpi-form-editor-move-section-modal-item-section-key]").attr("aria-label",__("Move section: %1$d").replace("%1$d",o));a.find("[data-glpi-form-editor-move-section-modal-item-section-name]").html(o);a.removeAttr("data-glpi-form-editor-move-section-modal-item-template");t.append(a)}));sortable($("[data-glpi-form-editor-move-section-modal-items]"),{handle:"[data-glpi-form-editor-section-handle]",placeholderClass:"glpi-form-editor-drag-section-placeholder"})}#S(){$(this.#t).find("[data-glpi-form-editor-move-section-modal]").modal("hide");$(this.#t).find("[data-glpi-form-editor-move-section-modal-items]").children().each(((t,e)=>{const i=$(e).find("[data-glpi-form-editor-move-section-modal-item-section-key]").data("glpi-form-editor-move-section-modal-item-section-key");const o=$(this.#t).find(`[data-glpi-form-editor-move-section-modal-uuid=${i}]`);o.remove().appendTo($(this.#t).find("[data-glpi-form-editor-blocks]"))}));$(this.#t).find("[data-glpi-form-editor-section]").each(((t,e)=>{this.#K($(e))}))}#K(t){const e=this.#Y(t);this.#Z(e)}#T(t){const e=t.prev();const i=t.find("[data-glpi-form-editor-section-blocks]").children();i.detach().appendTo(e.find("[data-glpi-form-editor-section-blocks]"));i.each(((t,e)=>{this.#K($(e))}));t.remove()}#E(t){t.toggleClass("section-collapsed")}#M(t){const e=this.#Y(t);const i=this.#G(t,t,"after",true);this.#Z(e);this.#L(i,"id",0);i.find("[data-glpi-form-editor-question]").each(((t,e)=>{this.#L($(e),"id",0)}));this.#y(i);this.#c(i)}#D(t){const e=this.#Y(t);const i=this.#G(t,t,"after",true);this.#Z(e);this.#L(i,"id",0);this.#y(i);$(document).trigger("glpi-form-editor-question-duplicated",[t,i])}#x(t){const e=this.#Y(t);const i=this.#G(t,t,"after");this.#Z(e);this.#L(i,"id",0);this.#y(i)}#j(){$(this.#t).find("[data-glpi-form-editor-empty-div]").remove();const t=$(this.#t).find("[data-glpi-form-editor-section]");t.each(((t,e)=>{const i=$(e).find("[data-glpi-form-editor-section-blocks]");if(i.children().length==0){i.append('<div data-glpi-form-editor-empty-div style="height: 1px"></div>')}}))}#Y(t){const e=[];t.find("textarea").each(((t,i)=>{const o=$(i).prop("id");const a=tinymce.get(o);if(a){a.destroy();e.push(o)}}));return e}#Z(t){t.forEach((t=>{tinymce.init(window.tinymce_editor_configs[t])}))}#u(){if(window.glpiUnsavedFormChanges){$(this.#t).find("[data-glpi-form-editor-preview-actions]").find("[data-glpi-form-editor-preview-action]").addClass("d-none");$(this.#t).find("[data-glpi-form-editor-preview-actions]").find("[data-glpi-form-editor-save-and-preview-action]").removeClass("d-none")}else{$(this.#t).find("[data-glpi-form-editor-preview-actions]").find("[data-glpi-form-editor-preview-action]").removeClass("d-none");$(this.#t).find("[data-glpi-form-editor-preview-actions]").find("[data-glpi-form-editor-save-and-preview-action]").addClass("d-none")}}#f(){const t=$(this.#t).find("[data-glpi-form-editor-form-details]");this.#y(t)}}